/* lib/random.js
 * Originally created 11/13/2018 by sapeck
 *
 * Copyright 2018-present sapeck
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
'use strict'

export default class Random {
  // From https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
  static getRandomInt (max) {
    return Math.floor(Math.random() * Math.floor(max))
  }

  static random (file, count) {
    let vm = this
    const contents = file.getContents()
    let indexes = []
    let out = []
    while (indexes.length < count) {
      let test = vm.getRandomInt(contents.length)
      if (!indexes.includes(test)) indexes.push(test)
    }
    for (let i of indexes) {
      out.push(contents[i])
    }
    return out
  }

  static random2 (file, count) {
    let vm = this
    const contents = file.getContents()
    let indexes = []
    let out = []
    while (indexes.length < count) {
      let test = vm.getRandomInt(contents.length)
      if (!indexes.includes(test) && test % 2 === 0) {
        indexes.push(test)
        indexes.push(test + 1)
      }
    }
    for (let i of indexes) {
      out.push(contents[i])
    }
    return out
  }
}
